/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.util.*;

public class BNgui extends Frame
{
	public BNapplet ParentApplet;
	public BNsystem system;
	public Vector nodes;
	public Vector links;

	public BNgui()
	{
		nodes = new Vector();
		links = new Vector();
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 633,getInsets().top + getInsets().bottom + 433);
		statusPallet = new Pallet();
		statusPallet.setLayout(null);
		statusPallet.setBounds(getInsets().left + 0,getInsets().top + 0,624,36);
		statusPallet.setBackground(new Color(12632256));
		add(statusPallet);
		choice1 = new java.awt.Choice();
		choice1.addItem("Edit");
		choice1.addItem("Run");
		statusPallet.add(choice1);
		choice1.setBounds(100,8,122,17);
		label1 = new java.awt.Label("Mode:");
		label1.setBounds(65,9,39,19);
		statusPallet.add(label1);
		displayCanvas1 = new DisplayCanvas();
		displayCanvas1.setBNgui(this);
		displayCanvas1.setBounds(getInsets().left + 0,getInsets().top + 36,624,384);
		displayCanvas1.setBackground(new Color(-2107947));
		add(displayCanvas1);
		setTitle("Untitled");
		//}}

		//{{INIT_MENUS
		mainMenuBar = new java.awt.MenuBar();
		FileMenu = new java.awt.Menu("File");
		fileNew = new java.awt.MenuItem("New");
		FileMenu.add(fileNew);
		fileOpen = new java.awt.MenuItem("Open");
		FileMenu.add(fileOpen);
		fileSave = new java.awt.MenuItem("Save");
		FileMenu.add(fileSave);
		fileSaveAs = new java.awt.MenuItem("Save As...");
		FileMenu.add(fileSaveAs);
		fileSaveNetFile = new java.awt.MenuItem("Save Net File...");
		FileMenu.add(fileSaveNetFile);
		fileClose = new java.awt.MenuItem("Close");
		FileMenu.add(fileClose);
		FileMenu.addSeparator();
		filePrinterSetup = new java.awt.MenuItem("Printer Setup...");
		FileMenu.add(filePrinterSetup);
		filePrint = new java.awt.MenuItem("Print...");
		FileMenu.add(filePrint);
		FileMenu.addSeparator();
		fileExit = new java.awt.MenuItem("Exit");
		FileMenu.add(fileExit);
		mainMenuBar.add(FileMenu);
		EditMenu = new java.awt.Menu("Edit");
		menuCreate = new java.awt.Menu("Create...");
		createNode = new java.awt.MenuItem("Node...");
		menuCreate.add(createNode);
		createLink = new java.awt.MenuItem("Link...");
		menuCreate.add(createLink);
		EditMenu.add(menuCreate);
		editCut = new java.awt.MenuItem("Cut");
		EditMenu.add(editCut);
		editCopy = new java.awt.MenuItem("Copy");
		EditMenu.add(editCopy);
		editPaste = new java.awt.MenuItem("Paste");
		EditMenu.add(editPaste);
		editDelete = new java.awt.MenuItem("Delete");
		EditMenu.add(editDelete);
		EditMenu.addSeparator();
		editAddState = new java.awt.MenuItem("Add State");
		EditMenu.add(editAddState);
		editDeleteState = new java.awt.MenuItem("Delete State");
		EditMenu.add(editDeleteState);
		EditMenu.addSeparator();
		editNOdeProperties = new java.awt.MenuItem("Node Properties...");
		EditMenu.add(editNOdeProperties);
		mainMenuBar.add(EditMenu);
		ViewMenu = new java.awt.Menu("View");
		viewExpandNodeList = new java.awt.MenuItem("Expand Node List");
		ViewMenu.add(viewExpandNodeList);
		viewCollapsNodeList = new java.awt.MenuItem("Collapse Node List");
		ViewMenu.add(viewCollapsNodeList);
		ViewMenu.addSeparator();
		viewLookEvidence = new java.awt.MenuItem("Look Evidence");
		ViewMenu.add(viewLookEvidence);
		viewShowMonitorWindow = new java.awt.MenuItem("Show Monitor Window");
		ViewMenu.add(viewShowMonitorWindow);
		viewUpdateAllMonitorGraphs = new java.awt.MenuItem("Update all Monitor Graphs");
		ViewMenu.add(viewUpdateAllMonitorGraphs);
		viewBeliefPrecision = new java.awt.MenuItem("Belief Precision...");
		ViewMenu.add(viewBeliefPrecision);
		ViewMenu.addSeparator();
		menuItem5 = new java.awt.MenuItem("Information...");
		ViewMenu.add(menuItem5);
		mainMenuBar.add(ViewMenu);
		NetworMenu = new java.awt.Menu("Network");
		netInitialize = new java.awt.MenuItem("Initilize");
		NetworMenu.add(netInitialize);
		NetworMenu.addSeparator();
		netEnterlikihood = new java.awt.MenuItem("Enter Liklihood");
		NetworMenu.add(netEnterlikihood);
		netRetractNode = new java.awt.MenuItem("Retract Node");
		NetworMenu.add(netRetractNode);
		NetworMenu.addSeparator();
		netNetworkProperties = new java.awt.MenuItem("Network Properties...");
		NetworMenu.add(netNetworkProperties);
		mainMenuBar.add(NetworMenu);
		OptionsMenu = new java.awt.Menu("Options");
		optionProperties = new java.awt.MenuItem("Properties...");
		OptionsMenu.add(optionProperties);
		optionPreferences = new java.awt.MenuItem("Preferences...");
		OptionsMenu.add(optionPreferences);
		mainMenuBar.add(OptionsMenu);
		menu1 = new java.awt.Menu("Help");
		helpTopics = new java.awt.MenuItem("Tpics of Help");
		menu1.add(helpTopics);
		helpAbout = new java.awt.MenuItem("About...");
		menu1.add(helpAbout);
		mainMenuBar.add(menu1);
		setMenuBar(mainMenuBar);
		//$$ mainMenuBar.setLocation(0,0);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		optionProperties.addActionListener(lSymAction);
		helpAbout.addActionListener(lSymAction);
		createNode.addActionListener(lSymAction);
		fileExit.addActionListener(lSymAction);
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		createLink.addActionListener(lSymAction);
		//}}
	}

	public BNgui(BNsystem s)
	{
		this();
		system = s;
	}

	public void setApplet(BNapplet a){
	    ParentApplet = a;
	}

	public synchronized void show()
	{
		setLocation(50, 50);
		super.show();
	}

///////////////////
    public void addNode(String name,int type,String desc,int id,int dimension)
    {
// If pos < 0 (out of field), then create new Node. else chenge property.
        displayCanvas1.addNode(name,type,desc,id,dimension);
        displayCanvas1.repaint();
    }
    public NodeView getSelectedNode()
    {
        return displayCanvas1.getSelectedNode();
    }
    public void addLink(int sNode,int eNode)
    {
        if (sNode != eNode){
            displayCanvas1.addLink(sNode,eNode);
            displayCanvas1.repaint();
        }
    }
///////////////////

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the getInsets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

//----- Appended by Hara

	BNsystem getSystem() { return system;}
	Vector 	 getNodes() { return nodes; }
	Vector   getLinks() { return links; }

    public void addTree()
    {
	getSelectedNode().addTree();
    }

    public void cloneTree()
    {
	getSelectedNode().cloneTree();
    }

    public void removeTree()
    {
	getSelectedNode().removeTree();
    }

    public void treeAt(int n)
    {
	getSelectedNode().treeAt(n);
    }

    public void prevTree()
    {
	getSelectedNode().prevTree();
    }

    public void nextTree()
    {
	getSelectedNode().nextTree();
    }

    public void activateTreeSelector()
    {
	getSelectedNode().activateTreeSelector();
    }
    public void deactivateTreeSelector()
    {
	getSelectedNode().deactivateTreeSelector();
    }

//-----

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	Pallet statusPallet;
	java.awt.Choice choice1;
	java.awt.Label label1;
	DisplayCanvas displayCanvas1;
	//}}
    
	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar;
	java.awt.Menu FileMenu;
	java.awt.MenuItem fileNew;
	java.awt.MenuItem fileOpen;
	java.awt.MenuItem fileSave;
	java.awt.MenuItem fileSaveAs;
	java.awt.MenuItem fileSaveNetFile;
	java.awt.MenuItem fileClose;
	java.awt.MenuItem filePrinterSetup;
	java.awt.MenuItem filePrint;
	java.awt.MenuItem fileExit;
	java.awt.Menu EditMenu;
	java.awt.Menu menuCreate;
	java.awt.MenuItem createNode;
	java.awt.MenuItem createLink;
	java.awt.MenuItem editCut;
	java.awt.MenuItem editCopy;
	java.awt.MenuItem editPaste;
	java.awt.MenuItem editDelete;
	java.awt.MenuItem editAddState;
	java.awt.MenuItem editDeleteState;
	java.awt.MenuItem editNOdeProperties;
	java.awt.Menu ViewMenu;
	java.awt.MenuItem viewExpandNodeList;
	java.awt.MenuItem viewCollapsNodeList;
	java.awt.MenuItem viewLookEvidence;
	java.awt.MenuItem viewShowMonitorWindow;
	java.awt.MenuItem viewUpdateAllMonitorGraphs;
	java.awt.MenuItem viewBeliefPrecision;
	java.awt.MenuItem menuItem5;
	java.awt.Menu NetworMenu;
	java.awt.MenuItem netInitialize;
	java.awt.MenuItem netEnterlikihood;
	java.awt.MenuItem netRetractNode;
	java.awt.MenuItem netNetworkProperties;
	java.awt.Menu OptionsMenu;
	java.awt.MenuItem optionProperties;
	java.awt.MenuItem optionPreferences;
	java.awt.Menu menu1;
	java.awt.MenuItem helpTopics;
	java.awt.MenuItem helpAbout;
	//}}
	CreateNode createNodePanel;
    PropertyFrame propertyFrame;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == optionProperties)
				optionProperties_Action(event);
			else if (object == helpAbout)
				helpAbout_Action(event);
			else if (object == createNode)
				createNode_Action(event);
			else if (object == fileExit)
				fileExit_Action(event);
			else if (object == createLink)
				createLink_Action(event);
		}
	}

	void optionProperties_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Create and show the Frame
		showPropertyFrame();
		//if (propertyFrame == null)  propertyFrame = new PropertyFrame();
		//propertyFrame.show();
		//}}
	}

	void helpAbout_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Create and show as modal
		(new AboutDialog(this, true)).setVisible(true);
		//}}
	}

	void createNode_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Create and show as modal
		(new CreateNode(this,true)).setVisible(true);
		//}}
	}
	
	void Show_createNodePanel(Node n){
	    CreateNode nodePanel = new CreateNode(this,true);
	    nodePanel.setNode(n);
	    
	    nodePanel.setVisible(true);
	}
	void Show_createNeuralNetDialog(Node n){
	    NeuralNetDialog NNDialog = new NeuralNetDialog(this,true);
	    NNDialog.setNode(n);
	    NNDialog.setVisible(true);
	}
    
    void showPropertyFrame()
    {
         if (propertyFrame == null)  propertyFrame = new PropertyFrame();
         if (propertyFrame == null){
            System.out.println("No Property!!");
         }else{
         //   System.out.println(propertyFrame.isValid());
         //   System.out.println(propertyFrame.isVisible());
            NodeView nodeName = getSelectedNode();
            if (nodeName != null) propertyFrame.setNode(nodeName.getNode());
            propertyFrame.setNodeSet(displayCanvas1.getNodes());
            
            propertyFrame.setVisible(true);
         }
    }
    
	void fileExit_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Hide the Frame
		exit();
		//}}
	}
	
	public void exit(){   
		if(ParentApplet!=null){
		   ParentApplet.exit();
		}else{
		   System.exit(0);
		}
	}


	class SymComponent extends java.awt.event.ComponentAdapter
	{
		public void componentResized(java.awt.event.ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == this)
				MainFrame_ComponentResized(event);
		}
	}

	void MainFrame_ComponentResized(java.awt.event.ComponentEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Repaint the DisplayCanvas
		{
		    displayCanvas1.setSize(getSize());
			displayCanvas1.repaint();
		}
		//}}
			 
		//{{CONNECTION
		// Repaint the Pallet
		{
		    statusPallet.setWidth(getSize().width -2);
			statusPallet.repaint();
		}
		//}}
	}

	void createLink_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Create and show as non-modal
		CreateLink Dialog = new CreateLink(this, false);
		Dialog.setNodes(displayCanvas1.getNodes());
		Dialog.setVisible(true);
		//}}
	}

	void createNode(Point pos){
// Without name of a node. -> set name as Node+nextID.
		NodeView nodeview = new NodeView(pos, new Node());
//        	(new Node()).setNodeView(nodeview);
	         nodes.addElement(nodeview);
	}

	void createNode(String name){
// With specific name of a node. -> set name as this name.
		NodeView nodeview = new NodeView(new Node(name));
//        	(new Node(name)).setNodeView(nodeview);
	         nodes.addElement(nodeview);
	}

	void createNode(String name, String property){
// With specific name of a node. -> set name as this name.
		NodeView nodeview = new NodeView(new Node(name));
//        	(new Node(name)).setNodeView(nodeview);
	         nodes.addElement(nodeview);
		 nodeview.getNode().setProperty(property);
	}

    public void removeNode(Node node){
         Vector tset = getContainTree(node); //Vector of Tree concerned with node.
         for (int i=0;i<tset.size(); i++){
//             ((TreeView)tset.elementAt(i)).getTree().removeNode(node);
             ((TreeView)tset.elementAt(i)).removeNode(node);
	}
         nodes.removeElement(node.getNodeView());
         Vector removeLinks = getRemoveLinks(node);
         for (int i=0;i<removeLinks.size();i++){
            links.removeElement(removeLinks.elementAt(i));
         }
    }

    Vector getContainTree(Node node)
    {
        Vector result = new Vector(1);
        
        for(int i=0;i<nodes.size();i++){
            Vector allTrees = ((NodeView)nodes.elementAt(i)).getTreeViewSet();
            for (int j=0 ; j< allTrees.size(); j++){
                TreeView t = (TreeView)allTrees.elementAt(j);
                if (t.getTree().containNode(node)) result.addElement(t);
            }
        }
        return result;
    }

    Vector getRemoveLinks(Node n)
    {
        Vector result= new Vector(1);
        for(int i=0;i<links.size();i++){
            Link link=(Link)links.elementAt(i);
            if (link.containNode(n.getNodeView()))
                result.addElement(link);
        }
        return result;
    }

}
