
import java.util.*;


public class Node extends myObject{

    public static int nextID;
    int ID;
    
    NodeView nodeView;
    Tree currentTree;
    Vector treeSet;
    TreeSelector treeSelector;
	

//----- Appended by Hara    
    int current;
//-----    

    int Type=1;
    int Dimension=1;
    String Description;
    int Status;
    Vector states;
    Vector statesName;



 public Node(){
	super();
        ID=nextID; nextID++;
        setName("Node"+ID);
        setDescription("");
        setType(1);
        setDimension(1);
        Status = 1;
        currentTree = new Tree();
	currentTree.setChild(this);
        current=0;
        states = new Vector(1);
        statesName = new Vector(1);
        addStates(1.0);
        treeSet = new Vector(1);
        treeSet.addElement(currentTree);
 }

 public Node(String name){
	this();
        setName(name);
 }

// Method to access variables...

 public void setNodeView(NodeView nv){
	nodeView = nv;
 }

 public NodeView getNodeView(){
	return nodeView;
 }

// Description
 public String getDescription(){
    return Description;
 }
 public void setDescription(String description){
    Description=new String(description);
 }

 // Type
 public int getType(){
    return Type;
 }
 public void setType(int type){
    Type = type;
 }

 // ID
 public int getID(){
    return ID;
 }

 // Status
 public void setStatus(int s) {
    Status = s;
 }
 public int getStatus() {
    return Status;
 }
 public void addStates(String name, double val) {
    states.addElement(new Double(val));
    statesName.addElement(name);
 }

 public void addStates(String name) {
    addStates(name,(double)1);
 }
 public void addStates(double val) {
    addStates("State "+Integer.toString(states.size()),val);
 }

 public void addStates() {
    addStates("State "+Integer.toString(states.size()));
 }

  public Vector getStates(){
    return states;
  }

  public Vector getStatesName(){
    return statesName;
  }

 public void setStatesName(Vector name){
    statesName = name;
 }

 public void setDimension(int dimension) {
    Dimension = dimension;
 }

 public Vector getParents(){
    return currentTree.getParents();
 }

 public Tree getTree(){
    return currentTree;
 }

 public Vector getTreeSet(){
    return treeSet;
 }

 public void setTree(Tree t){
    treeSet.addElement(t);
 }

 public int getDimension(){
    return Dimension;
 }

 public void addTreeSelector(){
	treeSelector = new TreeSelector();
	treeSelector.setNode(this);
 }
 
//----- Appended by Hara
 public void addTree()
 {
     currentTree = new Tree();
     currentTree.setChild(this);
     treeSet.addElement(currentTree);
     current = treeSet.size() - 1;
 }

 public void cloneTree()
 {
     Tree prevTree = currentTree;
     addTree();
     currentTree.setParents((Vector)prevTree.getParents().clone());
     currentTree.setLinks((Vector)prevTree.getLinks().clone());

 }

 public void removeTree()
 {
     if (treeSet.size() == 1){
       treeSet.removeElementAt(current);
       addTree();
     }else{
       treeSet.removeElementAt(current);
       if(current < treeSet.size()){
        currentTree=(Tree)treeSet.elementAt(current);
       }else{
	current--;
        currentTree=(Tree)treeSet.elementAt(current);
       }
    }
 }

 public void treeAt(int n)
 {
   if (n < treeSet.size()) {
	 currentTree = (Tree)treeSet.elementAt(n);
	 current = n;
   }
 }

 public void nextTree()
 {
      int next = (current+1) % treeSet.size();
      treeAt(next);
 }

 public void prevTree()
 {
      int prev = (current-1 + treeSet.size()) % treeSet.size();
      treeAt(prev);
 }

 public void activateTreeSelector(){
	if(treeSelector==null){ addTreeSelector();}
	treeSelector.start();
 }
 public void deactivateTreeSelector(){
	if(treeSelector!=null){
		treeSelector.stop();
	}
 }
//-----
}
