import java.awt.*;
import java.util.*;

public class Pallet extends Panel
{
    private boolean Active;

    /* Constructors */
    public Pallet(){
        this(true);
    }
    public Pallet(boolean act)
    {
        super();
        Active = act;
        setLayout(null);
        setBackground(Color.lightGray);
    }
    /*
        set/get Active
    */
    public void setActive(boolean act)
    {
        Active = act;
        if (act){setVisible(true);}
        else{setVisible(false);}
    }

    public boolean getActive()
    {
        return Active;
    }
    public void setWidth(int width)
    {
        Dimension size = getSize();
        size.width = width ;
        setSize(size);
        paint(getGraphics());
    }
    /*
        paint (called from update)
    */
    public void paint(Graphics g){
        super.paint(g);
        g.setColor(Color.lightGray);
        g.draw3DRect(0,0,getSize().width-1,getSize().height-1,true);
        g.draw3DRect(1,1,getSize().width-3,getSize().height-3,true);

    }
}


