/*
	A basic extension of the java.awt.Frame class
 */

import java.awt.*;
import java.util.*;

public class PropertyFrame extends Frame
{
	NeuralNetwork neuralNet;

	public PropertyFrame()
	{
		//{{INIT_CONTROLS
		setLayout(null);
		setVisible(false);
		setSize(getInsets().left + getInsets().right + 505,getInsets().top + getInsets().bottom + 451);
		setBackground(new Color(12632256));
		CloseButton = new java.awt.Button();
		CloseButton.setActionCommand("button");
		CloseButton.setLabel("Close");
		CloseButton.setBounds(getInsets().left + 278,getInsets().top + 416,89,21);
		CloseButton.setBackground(new Color(12632256));
		add(CloseButton);
		ApplyButton = new java.awt.Button();
		ApplyButton.setActionCommand("button");
		ApplyButton.setLabel("Apply");
		ApplyButton.setBounds(getInsets().left + 376,getInsets().top + 416,89,21);
		ApplyButton.setBackground(new Color(12632256));
		add(ApplyButton);
		pallet1 = new Pallet();
		pallet1.setActive(false);
		pallet1.setLayout(null);
		pallet1.setVisible(false);
		pallet1.setBounds(getInsets().left + 37,getInsets().top + 58,420,336);
		pallet1.setForeground(new Color(0));
		pallet1.setBackground(new Color(12632256));
		add(pallet1);
		label_LearningProperties = new java.awt.Label("Learning Parameters",Label.CENTER);
		label_LearningProperties.setBounds(48,34,126,18);
		label_LearningProperties.setForeground(new Color(0));
		pallet1.add(label_LearningProperties);
		label_Condition = new java.awt.Label("Condition for Leaning Termination",Label.CENTER);
		label_Condition.setBounds(36,142,216,18);
		label_Condition.setForeground(new Color(0));
		pallet1.add(label_Condition);
		checkbox_Iteration = new java.awt.Checkbox("Iteration");
		checkbox_Iteration.setBounds(60,166,108,18);
		checkbox_Iteration.setForeground(new Color(0));
		pallet1.add(checkbox_Iteration);
		checkbox_Iteration.setState(true);
		checkbox_threshold = new java.awt.Checkbox("Error threshold");
		checkbox_threshold.setBounds(60,190,108,18);
		pallet1.add(checkbox_threshold);
		checkbox_threshold.setState(true);
		textField_Iteration = new java.awt.TextField();
		textField_Iteration.setText("100");
		textField_Iteration.setBounds(168,166,159,24);
		textField_Iteration.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet1.add(textField_Iteration);
		textField_Threshold = new java.awt.TextField();
		textField_Threshold.setText("0.01");
		textField_Threshold.setBounds(168,190,159,24);
		textField_Threshold.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet1.add(textField_Threshold);
		label_Efficiency = new java.awt.Label("Efficiency");
		label_Efficiency.setBounds(84,70,72,18);
		pallet1.add(label_Efficiency);
		label_Momentum = new java.awt.Label("Momentum");
		label_Momentum.setBounds(72,94,72,18);
		pallet1.add(label_Momentum);
		textField_Efficiency = new java.awt.TextField();
		textField_Efficiency.setText("0.1");
		textField_Efficiency.setBounds(168,70,144,24);
		textField_Efficiency.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet1.add(textField_Efficiency);
		textField_Momentum = new java.awt.TextField();
		textField_Momentum.setText("0.1");
		textField_Momentum.setBounds(168,94,144,24);
		textField_Momentum.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet1.add(textField_Momentum);
		pallet2 = new Pallet();
		pallet2.setLayout(null);
		pallet2.setVisible(false);
		pallet2.setBounds(getInsets().left + 34,getInsets().top + 21,447,360);
		pallet2.setBackground(new Color(12632256));
		add(pallet2);
		label_WeightFileName = new java.awt.Label("Weight File Name:");
		label_WeightFileName.setBounds(22,37,108,18);
		pallet2.add(label_WeightFileName);
		textField_WeightFileName = new java.awt.TextField();
		textField_WeightFileName.setBounds(132,36,233,24);
		textField_WeightFileName.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet2.add(textField_WeightFileName);
		label_UnitNo = new java.awt.Label("Unit No.");
		label_UnitNo.setBounds(60,108,60,18);
		pallet2.add(label_UnitNo);
		label_InputNodes = new java.awt.Label("Input Nodes");
		label_InputNodes.setBounds(60,132,84,18);
		pallet2.add(label_InputNodes);
		label_OutputNodes = new java.awt.Label("Output Nodes");
		label_OutputNodes.setBounds(60,180,84,18);
		pallet2.add(label_OutputNodes);
		label_HiddenNodes = new java.awt.Label("Hidden Nodes");
		label_HiddenNodes.setBounds(60,156,84,18);
		pallet2.add(label_HiddenNodes);
		label_InputNodesValue = new java.awt.Label("2");
		label_InputNodesValue.setBounds(168,132,48,18);
		pallet2.add(label_InputNodesValue);
		label_OutputNodeValue = new java.awt.Label("1");
		label_OutputNodeValue.setBounds(168,180,50,18);
		pallet2.add(label_OutputNodeValue);
		label_UnitInformation = new java.awt.Label("Unit Information ");
		label_UnitInformation.setBounds(24,84,108,18);
		pallet2.add(label_UnitInformation);
		label_LearningHistory = new java.awt.Label("Learning History");
		label_LearningHistory.setBounds(24,228,120,18);
		pallet2.add(label_LearningHistory);
		label_NumberOfIteration = new java.awt.Label("Number of iteration");
		label_NumberOfIteration.setBounds(48,252,120,18);
		pallet2.add(label_NumberOfIteration);
		label_NumberOfIterationValue = new java.awt.Label("0");
		label_NumberOfIterationValue.setBounds(204,252,66,18);
		pallet2.add(label_NumberOfIterationValue);
		label_InitialValue = new java.awt.Label("Inital Value");
		label_InitialValue.setBounds(48,276,105,18);
		pallet2.add(label_InitialValue);
		label_InitialValueValue = new java.awt.Label("1234567890");
		label_InitialValueValue.setBounds(204,276,122,18);
		pallet2.add(label_InitialValueValue);
		label_SampleDate = new java.awt.Label("Teach data for learning");
		label_SampleDate.setBounds(48,300,144,18);
		pallet2.add(label_SampleDate);
		choice_SampleDate = new java.awt.Choice();
		choice_SampleDate.addItem("File");
		choice_SampleDate.addItem("PostgreSQL");
		choice_SampleDate.addItem("Oracle");
		try {
			choice_SampleDate.select(0);
		} catch (IllegalArgumentException e) { }
		pallet2.add(choice_SampleDate);
		choice_SampleDate.setBounds(204,300,132,18);
		choice_SampleDate.setFont(new Font("Dialog", Font.PLAIN, 10));
		choice_UnitNo = new java.awt.Choice();
		pallet2.add(choice_UnitNo);
		choice_UnitNo.setBounds(168,108,69,18);
		choice_UnitNo.setFont(new Font("Dialog", Font.PLAIN, 10));
		textField_HiddenNodes = new java.awt.TextField();
		textField_HiddenNodes.setText("10");
		textField_HiddenNodes.setBounds(165,153,63,24);
		textField_HiddenNodes.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet2.add(textField_HiddenNodes);
		buttonCreateNN = new java.awt.Button();
		buttonCreateNN.setLabel("Create Neural Net");
		buttonCreateNN.setBounds(271,179,136,23);
		buttonCreateNN.setBackground(new Color(12632256));
		pallet2.add(buttonCreateNN);
		buttonLoad = new java.awt.Button();
		buttonLoad.setLabel("Load");
		buttonLoad.setBounds(211,66,71,20);
		buttonLoad.setBackground(new Color(12632256));
		pallet2.add(buttonLoad);
		buttonSave = new java.awt.Button();
		buttonSave.setLabel("Save");
		buttonSave.setBounds(286,66,71,20);
		buttonSave.setBackground(new Color(12632256));
		pallet2.add(buttonSave);
		buttonFileDialog = new java.awt.Button();
		buttonFileDialog.setLabel("...");
		buttonFileDialog.setBounds(363,36,27,24);
		buttonFileDialog.setBackground(new Color(12632256));
		pallet2.add(buttonFileDialog);
		pallet3 = new Pallet();
		pallet3.setActive(false);
		pallet3.setLayout(null);
		pallet3.setVisible(false);
		pallet3.setBounds(getInsets().left + 24,getInsets().top + 25,462,378);
		pallet3.setBackground(new Color(12632256));
		add(pallet3);
		label_DatebaseInterface = new java.awt.Label("Database Interface:");
		label_DatebaseInterface.setBounds(15,146,108,17);
		pallet3.add(label_DatebaseInterface);
		label_DatabaseURL = new java.awt.Label("URL:");
		label_DatabaseURL.setBounds(16,178,39,20);
		pallet3.add(label_DatabaseURL);
		label_SQLStatement = new java.awt.Label("SQL Statement");
		label_SQLStatement.setBounds(16,234,96,18);
		pallet3.add(label_SQLStatement);
		label_UserName = new java.awt.Label("User Name:");
		label_UserName.setBounds(12,212,72,18);
		pallet3.add(label_UserName);
		label_Password = new java.awt.Label("Password:");
		label_Password.setBounds(234,212,60,18);
		pallet3.add(label_Password);
		choice_DatabaseInterface = new java.awt.Choice();
		choice_DatabaseInterface.addItem("PostgeSQL");
		choice_DatabaseInterface.addItem("dbAnywhere");
		choice_DatabaseInterface.addItem("Table");
		choice_DatabaseInterface.addItem("BuiltIn");
		try {
			choice_DatabaseInterface.select(0);
		} catch (IllegalArgumentException e) { }
		pallet3.add(choice_DatabaseInterface);
		choice_DatabaseInterface.setBounds(137,145,257,24);
		choice_DatabaseInterface.setFont(new Font("Dialog", Font.PLAIN, 10));
		textField_DatabaseURL = new java.awt.TextField();
		textField_DatabaseURL.setBounds(63,175,382,24);
		textField_DatabaseURL.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet3.add(textField_DatabaseURL);
		textField_UserName = new java.awt.TextField();
		textField_UserName.setBounds(86,208,137,24);
		textField_UserName.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet3.add(textField_UserName);
		textField_Password = new java.awt.TextField();
		textField_Password.setEchoChar('*');
		textField_Password.setBounds(302,208,145,24);
		textField_Password.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet3.add(textField_Password);
		textArea_SQLstatement = new java.awt.TextArea();
		textArea_SQLstatement.setBounds(36,257,386,87);
		textArea_SQLstatement.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet3.add(textArea_SQLstatement);
		choice1 = new java.awt.Choice();
		choice1.addItem("Built-In");
		choice1.addItem("DataBase");
		choice1.addItem("Table");
		pallet3.add(choice1);
		choice1.setBounds(114,17,215,24);
		choice1.setFont(new Font("Dialog", Font.PLAIN, 10));
		label1 = new java.awt.Label("DataSet Type:");
		label1.setBounds(24,19,84,25);
		pallet3.add(label1);
		textField_TableFile = new java.awt.TextField();
		textField_TableFile.setBounds(115,93,202,24);
		textField_TableFile.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet3.add(textField_TableFile);
		label2 = new java.awt.Label("TableFile:");
		label2.setBounds(37,95,63,24);
		pallet3.add(label2);
		label3 = new java.awt.Label("BuiltIn:");
		label3.setBounds(48,55,47,24);
		pallet3.add(label3);
		choice_BuiltIn = new java.awt.Choice();
		choice_BuiltIn.addItem("XOR");
		pallet3.add(choice_BuiltIn);
		choice_BuiltIn.setBounds(113,53,216,24);
		choice_BuiltIn.setFont(new Font("Dialog", Font.PLAIN, 10));
		pallet4 = new Pallet();
		pallet4.setActive(false);
		pallet4.setLayout(null);
		pallet4.setVisible(false);
		pallet4.setBounds(getInsets().left + 22,getInsets().top + 62,457,336);
		pallet4.setBackground(new Color(12632256));
		add(pallet4);
		graphCanvas1 = new GraphCanvas();
		graphCanvas1.setBounds(30,34,380,233);
		pallet4.add(graphCanvas1);
		buttonStartLearning = new java.awt.Button();
		buttonStartLearning.setLabel("Start ");
		buttonStartLearning.setBounds(200,300,119,24);
		buttonStartLearning.setBackground(new Color(12632256));
		pallet4.add(buttonStartLearning);
		button_Reset = new java.awt.Button();
		button_Reset.setLabel("Reset");
		button_Reset.setBounds(326,300,110,23);
		button_Reset.setBackground(new Color(12632256));
		pallet4.add(button_Reset);
		buttonOption = new java.awt.Button();
		buttonOption.setActionCommand("button");
		buttonOption.setLabel("Opion");
		buttonOption.setBounds(getInsets().left + 181,getInsets().top + 416,89,21);
		buttonOption.setBackground(new Color(12632256));
		add(buttonOption);
		choiceNode = new java.awt.Choice();
		add(choiceNode);
		choiceNode.setBounds(getInsets().left + 39,getInsets().top + 413,116,23);
		setTitle("Property Frame");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymMouse aSymMouse = new SymMouse();
		SymAction lSymAction = new SymAction();
		CloseButton.addActionListener(lSymAction);
		buttonStartLearning.addActionListener(lSymAction);
		buttonCreateNN.addActionListener(lSymAction);
		button_Reset.addActionListener(lSymAction);
		ApplyButton.addActionListener(lSymAction);
		choice1.addMouseListener(aSymMouse);
		buttonFileDialog.addActionListener(lSymAction);
		choiceNode.addMouseListener(aSymMouse);
		buttonLoad.addActionListener(lSymAction);
		buttonSave.addActionListener(lSymAction);
		//}}
		
		//{{TabPanel
		//  CloseButton.setLocation(getInsets().left + 240,getSize().height-36);
		//  ApplyButton.setLocation(getInsets().left + 336,getSize().height-36);
	
          mainTabPanel = new TabPanel();
          mainTabPanel.setBounds(12,0,getSize().width-24,getSize().height-48);
          add(mainTabPanel);	
          mainTabPanel.addPallet("Learning Parameters",pallet1);
          mainTabPanel.addPallet("NeuralNet..",pallet2);
          mainTabPanel.addPallet("DataSet...",pallet3);
          mainTabPanel.addPallet("Monitor",pallet4);
        //}}
	}

	public PropertyFrame(String title)
	{
		this();
		setTitle(title);
	}

	public synchronized void show()
	{
		move(50, 50);
		super.show();
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the getInsets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Button CloseButton;
	java.awt.Button ApplyButton;
	Pallet pallet1;
	java.awt.Label label_LearningProperties;
	java.awt.Label label_Condition;
	java.awt.Checkbox checkbox_Iteration;
	java.awt.Checkbox checkbox_threshold;
	java.awt.TextField textField_Iteration;
	java.awt.TextField textField_Threshold;
	java.awt.Label label_Efficiency;
	java.awt.Label label_Momentum;
	java.awt.TextField textField_Efficiency;
	java.awt.TextField textField_Momentum;
	Pallet pallet2;
	java.awt.Label label_WeightFileName;
	java.awt.TextField textField_WeightFileName;
	java.awt.Label label_UnitNo;
	java.awt.Label label_InputNodes;
	java.awt.Label label_OutputNodes;
	java.awt.Label label_HiddenNodes;
	java.awt.Label label_InputNodesValue;
	java.awt.Label label_OutputNodeValue;
	java.awt.Label label_UnitInformation;
	java.awt.Label label_LearningHistory;
	java.awt.Label label_NumberOfIteration;
	java.awt.Label label_NumberOfIterationValue;
	java.awt.Label label_InitialValue;
	java.awt.Label label_InitialValueValue;
	java.awt.Label label_SampleDate;
	java.awt.Choice choice_SampleDate;
	java.awt.Choice choice_UnitNo;
	java.awt.TextField textField_HiddenNodes;
	java.awt.Button buttonCreateNN;
	java.awt.Button buttonLoad;
	java.awt.Button buttonSave;
	java.awt.Button buttonFileDialog;
	Pallet pallet3;
	java.awt.Label label_DatebaseInterface;
	java.awt.Label label_DatabaseURL;
	java.awt.Label label_SQLStatement;
	java.awt.Label label_UserName;
	java.awt.Label label_Password;
	java.awt.Choice choice_DatabaseInterface;
	java.awt.TextField textField_DatabaseURL;
	java.awt.TextField textField_UserName;
	java.awt.TextField textField_Password;
	java.awt.TextArea textArea_SQLstatement;
	java.awt.Choice choice1;
	java.awt.Label label1;
	java.awt.TextField textField_TableFile;
	java.awt.Label label2;
	java.awt.Label label3;
	java.awt.Choice choice_BuiltIn;
	Pallet pallet4;
	GraphCanvas graphCanvas1;
	java.awt.Button buttonStartLearning;
	java.awt.Button button_Reset;
	java.awt.Button buttonOption;
	java.awt.Choice choiceNode;
	//}}

	//{{DECLARE_MENUS
	//}}
	
    
    
    //{{ My cording
        
    TabPanel mainTabPanel;
    Node node;
    Vector nodeSet;
	   
    public void setNode(Node n)
    {
        node = n;
	if(node.getTree().getParents()!=null){
	        label_InputNodesValue.setText(Integer.toString(node.getTree().getInputNodeSize()));
        	label_OutputNodeValue.setText(Integer.toString(node.getTree().getOutputNodeSize()));
	}
//        update(getGraphics());
    }
    
        
    int getHiddenNumber()
	{
	    return (Integer.parseInt(textField_HiddenNodes.getText()));
	}
	double getEfficiency()
	{
	    return ((Double.valueOf(textField_Efficiency.getText())).doubleValue());
	}
	double getMomentum()
	{
	    return ((Double.valueOf(textField_Momentum.getText())).doubleValue());
	}
	int getIteration()
	{
	     return (Integer.parseInt(textField_Iteration.getText()));
	}
	double getThreshold()
	{
	    return ((Double.valueOf(textField_Threshold.getText())).doubleValue());
	}
     
     
    //}}
    
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == PropertyFrame.this)
				Frame1_WindowClosing(event);
		}
	}
	
	void Frame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		hide();		 // hide the Frame
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == choice1)
				choice1_MouseRelease(event);
			else if (object == choiceNode)
				choiceNode_MouseRelease(event);
		}
	}

	void OkButton_MouseRelease(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Hide the Frame
		setVisible(false);
		//}}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == CloseButton)
				CancelButton_Action(event);
			else if (object == buttonStartLearning)
				buttonStartLearning_Action(event);
			else if (object == buttonCreateNN)
				buttonCreateNN_Action(event);
			else if (object == button_Reset)
				buttonReset_Action(event);
			else if (object == ApplyButton)
				ApplyButton_Action(event);
			else if (object == buttonFileDialog)
				buttonFileDialog_Action(event);
			else if (object == buttonLoad)
				buttonLoad_Action(event);
			else if (object == buttonSave)
				buttonSave_Action(event);
		}
	}

	void CancelButton_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Hide the Frame
		setVisible(false);
		//}}
	}


	void buttonStartLearning_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Set the Button's label...
		if (buttonStartLearning.getLabel() != "Suspend"){
		    buttonStartLearning.setLabel("Suspend");
		    startLearning();
		}else{
		    buttonStartLearning.setLabel("Restart");   
		   // neuralNet.resetLearning();
		    suspendLearning();
		}    
		//}}
		
		
	}

	void buttonCreateNN_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Disable the Button
		//buttonCreateNN.setEnabled(false);
		createNeuralNetwork();
		//}}
	}
	
	void createNeuralNetwork()
	{
	  if(node!= null){
	    node.getTree().createNeuralNetwork(getHiddenNumber(),getEfficiency(),getMomentum(),getIteration(),getThreshold());
	    neuralNet = node.getTree().getNeuralNetwork();
   	    neuralNet.setGraph(graphCanvas1);
	  }
	}
	
	boolean SuspendLearning = false;
	void startLearning()
	{
	    if (SuspendLearning){
	        neuralNet.restartLearn();
	    }else{
	        neuralNet.startLearn();
	    }
	}
	void suspendLearning()
	{
	    neuralNet.suspendLearn();
	    SuspendLearning = true;
	}

	void buttonReset_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Set the Button's label...
		buttonStartLearning.setLabel("Start");
		SuspendLearning = false;
		//}}

	    graphCanvas1.resetAll();
	    neuralNet.resetLearning();

	}

	void buttonDataSet_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Create and show the Frame
		(new DataSetFrame()).show();
		//}}
	}

	void ApplyButton_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Enable the Pallet
		{
			Pallet activePallet = mainTabPanel.getActivePallet();
			if (activePallet == pallet1){
			    neuralNet.setEfficiency(getEfficiency());
			    neuralNet.setMomentum(getMomentum());
			    if (checkbox_threshold.getState())
			        neuralNet.setIteration(getIteration());
			    else neuralNet.setIteration(10000);
			    if (checkbox_Iteration.getState())
			        neuralNet.setThreshold(getThreshold());
			    else neuralNet.setThreshold(0.001);
			    
			}else if (activePallet == pallet2){
			    neuralNet.setWeightFile(textField_WeightFileName.getText());
			}else if (activePallet == pallet3){
			    getPattern(choice1.getSelectedIndex());
			}else if (activePallet == pallet4){
			}
		}
		//}}
	}

	void choice1_MouseRelease(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
	    int selected = choice1.getSelectedIndex();
	    if (selected == 0){
	        enableBuiltIn(true);
	        enableTableField(false);
	        enableDataBaseField(false);
	    }else if (selected == 1){
	        enableBuiltIn(false);
	        enableTableField(true);
	        enableDataBaseField(false);
	    }else {
	        enableBuiltIn(false);
	        enableTableField(false);
	        enableDataBaseField(true);
	    }
	}
	void enableBuiltIn(boolean b){
	    choice_BuiltIn.setEnabled(b);
	}
	void enableTableField(boolean b){
	    textField_TableFile.setEnabled(b);
	}
	void enableDataBaseField(boolean b){
	    choice_DatabaseInterface.setEnabled(b);
	    textField_DatabaseURL.setEnabled(b);
	    textField_UserName.setEnabled(b);
	    textField_Password.setEnabled(b);
	    textArea_SQLstatement.setEnabled(b);
	}
	
	void getPattern(int type)
	{
        if(type == 0){
            neuralNet.getTeachPattern(new XOR());
        }
	}
  

	void buttonFileDialog_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		//{{CONNECTION
		// Enable the TextField
		//textField_WeightFileName.setEnabled(true);
		//}}
		FileDialog fileDialog;
		fileDialog = new FileDialog(this);
		fileDialog.setVisible(true);
		
		textField_WeightFileName.setText(fileDialog.getDirectory() + fileDialog.getFile());
		neuralNet.setWeightFileDir(fileDialog.getDirectory());
		neuralNet.setWeightFile(fileDialog.getFile());
	}
	public void setNodeSet(Vector nodeset)
	{
	    nodeSet = nodeset;
	    choiceNode.removeAll();
	    for (int i=0; i<nodeSet.size();i++){
	        NodeView n = (NodeView)nodeSet.elementAt(i);
// set Target Node as default
		if(node == null){ setNode(n.getNode());}
	        choiceNode.add(n.getNode().getName());
	    }
	}

	void choiceNode_MouseRelease(java.awt.event.MouseEvent event)
	{
		// to do: code goes here.
			 
        setNode((Node)nodeSet.elementAt(choiceNode.getSelectedIndex()));
	}

	void buttonLoad_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.

		neuralNet.LoadWeights();

	}

	void buttonSave_Action(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		neuralNet.SaveWeights();
	}
}
