/*
   TabPanel Class:

   Quick Start:

      1.Create Pallet-Objects and Edited by using Visual Cafe etc.
      2.Write as following...
        tabPanels = new PanelTab();
        tabPanels.setBounds(0,0,getSize().width,getSize().height-36);
        add(tabPanels);

        tabPanels.addTabPanel("Tab 1", pallet1);
        tabPanels.addTabPanel("Tab 2", pallet2);
            ....

//       Declare
        PanelTab tabPanel;
*/
import java.awt.*;
import java.util.*;

public class TabPanel extends Panel
{
    // Constructors

	public TabPanel()
	{
	    super();
        setLayout(null);
        Tabs = 0;
        Labels = new Vector(1);
        Pallets = new Vector(1);
		MA = new mouseAdapter();
		ActivePallet = null;

	}

	// Add Pallet
    void addPallet(String tabName, Pallet pallet)
    {
        PalletLabel palletLabel;
        int TabStep = 0;
        for (int i=0;i<Tabs;i++){
            TabStep += (((PalletLabel)(Labels.elementAt(i))).getSize()).width;
        }

        if( Tabs == 0 ){
             palletLabel = new PalletLabel(tabName,1,true);
             pallet.setActive(true);
             ActivePallet = pallet;
        }else {
		     palletLabel = new PalletLabel(tabName,1,false);
		     pallet.setActive(false);
		}

		palletLabel.setBounds(getInsets().left + 12+TabStep,getInsets().top + 18,tabName.length()*6+12, 26);
		add(palletLabel);

		pallet.setLayout(null);
		pallet.setBounds(getInsets().left + 12,getInsets().top + 42,getSize().width -26,getSize().height-48);
		add(pallet);

        palletLabel.addMouseListener(MA);
        Labels.addElement(palletLabel);
        Pallets.addElement(pallet);
        Tabs++;
    }

    public Pallet getActivePallet()
    {
         return ActivePallet;
    }
	// Mouse Event Adapter
	class mouseAdapter extends java.awt.event.MouseAdapter
	{
		public void mousePressed(java.awt.event.MouseEvent event)
		{
			tabLabel_mousePressed(event);
		}
	}

	void tabLabel_mousePressed(java.awt.event.MouseEvent event)
	{
	    Object object = event.getSource();
	    int pos = SelectObject(object);
	    int i;

	    for(i=0; i< Tabs; i++){
		    boolean Active;
	        PalletLabel palletLabel = (PalletLabel)Labels.elementAt(i);
	        Pallet pallet = (Pallet)Pallets.elementAt(i);
	        if (i == pos){ Active = true; ActivePallet = pallet;}
	        else {Active = false; }

	        palletLabel.setActive(Active);
		    pallet.setActive(Active);
        }
	}

	int SelectObject(Object obj)
	{
	    int i;
	    for(i=0; i< Tabs; i++){
	        if (obj == Labels.elementAt(i)) return i;
	    }
	    return i;
	}

	// Variavles
	Vector Labels;
	Vector Pallets;
	int Tabs;
	mouseAdapter MA;
	Pallet ActivePallet;

}
