import java.lang.*;

import BNgui;
import BNsystem;
import TCP;
import TCPserver;
import myObject;

public class  BNstart
    implements TCPserver, STDserver
{
    static final int Default_PORT= 6700;
    BNgui gui;
    BNsystem system;
    static String defaultGraphFile= "start.bn"; 

    public BNstart(){ }

    public void init(){
        system= new BNsystem(); 
        system.setName("system"); 
        if (gui== null) 
        {
            gui= new BNgui(system); 
        }
        gui.show(); 
        system.setGUI(gui); 
        system.loadFile(defaultGraphFile); 
	new TCP(Default_PORT, this);
//	new STD(this);
    }

    public void service(String in, StringBuffer out){
        system.command(in, out); 
    }

    public static void main(String[] arg){
        new BNstart().init(); 
    }

}

