import java.lang.*;

import BNgui;
import Node;
import java.util.StringTokenizer;
import myObject;

public class  BNsystem extends myObject{
    BNgui gui;

    public BNsystem(){
       name= "system"; 
    }

    public final void loadFile(String in, StringBuffer out){
        loadFile(in); out.append("ok"); 
    }

    public final void loadFile(String in){
//        loadFile(in); 
    }

    public final void saveFile(String in, StringBuffer out){  }

    public final void exit(String dumy)
    {
	if(gui!=null){
           gui.exit(); 
	}
    }

    public void command(String in){
	StringBuffer out = new StringBuffer();
	command(in, out);
//      gui.printMessage(out.toString());
System.out.println(out.toString());
	return;
    }

    public void command(String in, StringBuffer out){
        StringTokenizer st;
        st = new StringTokenizer(in); 
        try{
            String cmnd = st.nextToken(); 
            if (cmnd.indexOf("#") != -1)
            {
                return; 
            }
            if ("exit".equals(cmnd))
            {
                exit(""); 
            }
            String method = st.nextToken(); 
            String arg;

            if ("loadFile".equals(cmnd))
            {
                loadFile(method, out); 
                return; 
            }
            if ("saveFile".equals(cmnd))
            {
                saveFile(method, out); 
                return; 
            }
            if (st.hasMoreTokens() == false)
            {
                arg = null; 
            }
            else
            {
                arg = in.substring((in.indexOf(method) + method.length())); 
            }
            if ("createNode".equals(cmnd))
            {
                createNode(method, arg); 
                return; 
            }
            if ("createObject".equals(cmnd))
            {
                createObject(method, arg); 
                return; 
            }
	    Object ret = myObject.performed(cmnd, method, arg);
	    if(ret != null){
               out.append(ret.toString()); 
	    }
            return; 
        }
        catch (java.util.NoSuchElementException NoSuchElementException0)
        {
            return; 
        }
    }

    public void setGUI(BNgui g)
    {
        gui= g; 
    }

    public void createNode(String name, String prop){
        if (gui== null) 
        {
            new Node().setName(name, prop); 
            return; 
        }
        gui.createNode(name, prop); 
    }

    public void createObject(String classname, String name){

        try{
	    myObject o = (myObject)(Class.forName(classname)).newInstance();
	    o.setName(name);
            return; 
        }catch(Exception e){}
	return;
    }
}

