// STD.java ... Listen on stdin, and retrun each responce to stdout

/* -------------------------------------------------------------------------
TCP.java ... STD in/out interface module for server side.

	usage: new STD(this) ... 

--------------------------------------------------------------------------*/
import java.io.*;
import java.util.*;

public class STD extends Thread {
        STDserver service; 
	DataInputStream din;

    public static void fail(Exception e, String msg){
	System.err.println(msg+":"+e); 
	System.exit(1);
    }


    STD(STDserver s) {
	din = new DataInputStream(System.in);
	service = s;
	this.start();
    }

    public void run(){
		String input=null;
		StringBuffer output;
		int len;

		   output = new StringBuffer();
		   for(;;){
		     try{
			sleep(100);
			input = din.readLine(); 
		     }catch(Exception e){}
			if(input==null)break;
			output.setLength(0); // Clear old trash in the buffer.
			service.service(input,output);
			if(output.length()!=0){
			   System.out.println(output);
			}
		    }
     }
}

