import java.util.*;
import java.awt.*;

class TreeView extends Object {

	Tree tree;
	Vector links;
    	int id;
		
		
    public TreeView() {
        super();
        links = new Vector(1);
    }
   
    public TreeView(int id){
	    this();
	    setId(id);
    }

    public void setId(int i){ id = i; }
    public int getId(){ return id; }
    public void setTree(Tree t){ tree = t; }
    public Tree getTree(){ return tree; }

    public Vector getLinks(){  return links; }
    public void setLinks(Vector l){ links = l;}
    public void addLink(Link l){   links.addElement(l); }
    public void removeLink(Link link) {links.removeElement(link);}
    public int linkSize() { return links.size(); }

    public void removeNode(Node node)
    {
	tree.removeNode(node);
	for(int i=0; i< links.size();i++){
	  	Link l=(Link)links.elementAt(i);
		if(l.containNode(node.getNodeView())) removeLink(l);
	}
    }
//----- Appended by Hara
    public synchronized void paint(Graphics g)
    {
	int i;
	for (i=0;i< links.size(); i++){
		Link link = (Link)links.elementAt(i);
		link.paint(g);
	}
    }
//-----
}


